=== debian/changelog ===
seqan (1.3-1ubuntu2) precise; urgency=low

  * debian/control: Add Pre-Depends to dpkg (>= 1.15.6~) to fix upload
    problem with xz compression, thanks to micahg for pointing this.

 -- Mahyuddin Susanto <udienz@ubuntu.com>  Wed, 18 Jan 2012 23:54:16 +0700

seqan (1.3-1ubuntu1) precise; urgency=low

  * Merge from Debian testing. Remaining changes:
    - debian/patches/ls-as-needed.patch: Fix FTBFS binutils gold with ld
      --as-needed.

 -- Mahyuddin Susanto <udienz@ubuntu.com>  Wed, 18 Jan 2012 17:21:10 +0700

seqan (1.3-1) unstable; urgency=low

  * Team upload.
  * New upstream release (Closes: #640302).

  [ Charles Plessy ]
  * Collected various informations in ‘debian/upstream-metadata.yaml’.
  * Compress the source and binary packages with xz
    (debian/orig-tar.sh, debian/rules).
  * Removed convenience code copy of samtools (debian/orig-tar.sh).
  * Use Debhelper 8 (debian/compat, debian/control).
  * Conforms to Policy 3.9.2 (debian/control, no other changes needed).
  * Built using the cmake class of CDBS (debian/rules).
  * debian/control:
    - Corrected VCS URLs.
    - Build-Depend on libboost-dev as Cmake was looking for it.
    - Build-Depend on zlib1g-dev, as seqan needs to detect zlib to set
      SEQAN_HAS_SAMTOOLS to 1.
    - Changed Priority from extra to optional.
    - Changed sequan-apps Section from libdevel to science.
  * debian/patch/samtools.patch corrects path to SAMtools headers.
  * Machine-readable debian/copyright.

  [ Andreas Tille ]
  * debian/control
    - added myself to uploaders
    - Standards-Version: 3.9.1 (no changes needed)
  * debian/watch: Allso catch RC candidates
  * debian/source/format: 3.0 (quilt)

 -- Charles Plessy <plessy@debian.org>  Fri, 16 Sep 2011 12:51:39 +0900

seqan (1.2-1ubuntu2) precise; urgency=low

  * No-change rebuild to drop spurious libsfgcc1 dependency on armhf.

 -- Adam Conrad <adconrad@0c3.net>  Fri, 02 Dec 2011 21:20:35 -0700

seqan (1.2-1ubuntu1) oneiric; urgency=low

  * Fix FTBFS with ld --as-needed. LP: #832793.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 19 Sep 2011 23:52:47 +0000

seqan (1.2-1) unstable; urgency=low

  * Initial Release  (Closes: #487361)

 -- Soeren Sonnenburg <sonne@debian.org>  Wed, 30 Sep 2009 20:41:39 +0200
