=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/cmake.mk

DEB_SRCDIR              := cmake
DEB_MAKE_INSTALL_TARGET :=

DEB_DH_BUILDDEB_ARGS = -- -Zxz

install/seqan-apps:: debian/stamp-install-seqan-apps
debian/stamp-install-seqan-apps:
	mkdir -p $(CURDIR)/debian/seqan-apps/usr/bin
	mkdir -p $(CURDIR)/debian/seqan-apps/usr/lib/sequan/bin
	mkdir -p $(CURDIR)/debian/seqan-apps/usr/share/doc/seqan-apps
	#install binaries
	for APP in dfi insegt mason micro_razers pair_align param_chooser rabema razers razers2 read_analyzer rep_sep sak seqan_tcoffee seqcons snp_store splazers stellar tree_recon ; do \
	  cp -p $(CURDIR)/obj*/apps/$$APP $(CURDIR)/debian/seqan-apps/usr/lib/sequan/bin/ ; done
	# Links for compatibility with seqan 1.2-1
	for APP in dfi micro_razers pair_align razers seqan_tcoffee seqcons tree_recon ; do \
	  ln -s /usr/lib/sequan/bin/$$APP $(CURDIR)/debian/seqan-apps/usr/bin/$$APP ; done
	#install readmes
	for APP in dfi insegt mason micro_razers razers razers2 sak seqan_tcoffee splazers stellar ; do \
	  cp -p $(CURDIR)/apps/$$APP/README $(CURDIR)/debian/seqan-apps/usr/share/doc/seqan-apps/README.$$APP ; done
	touch $@

install/seqan-dev:: debian/stamp-install-seqan-dev
debian/stamp-install-seqan-dev:
	mkdir -p $(CURDIR)/debian/seqan-dev/usr/include
	mkdir -p $(CURDIR)/debian/seqan-dev/usr/share/doc/seqan-dev
	cp -a $(CURDIR)/seqan $(CURDIR)/debian/seqan-dev/usr/include/
	cp -a $(CURDIR)/demos $(CURDIR)/debian/seqan-dev/usr/share/doc/seqan-dev
	cp -a $(CURDIR)/doc $(CURDIR)/debian/seqan-dev/usr/share/doc/seqan-dev
	touch $@

get-orig-source:
	uscan --force-download
	@echo successfully retrieved upstream tarball

clean::
	$(RM) -r debian/stamp-*
